/**
 * Copyright (c) 2001/2003 Distributed Systems Research Group.
 * All rights reserved.
 *
 * For more information on Distributed Systems Research Group (DSRG),
 * please see <http://www.ics.agh.edu.pl/>.
 *
 * @author radzisz
 * file name: NoteClient.java
 *
 */
package edu.agh.sr.radzisz;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.WindowConstants;

public class NoteBoardClient extends JFrame {

	JTextArea textArea = new JTextArea(30, 60);
	JButton bClear = new JButton("clear");
	JButton bAppend = new JButton("append");
	JButton bGet = new JButton("get");
	JTextField userName = new JTextField(10);
	JTextField text = new JTextField(50);
	NoteBoard board;

	NoteBoardClient() {
		super("NoteClient");

		bClear.addActionListener(new ActionHandler());
		bGet.addActionListener(new ActionHandler());
		bAppend.addActionListener(new ActionHandler());

		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		JScrollPane scrollPane =
			new JScrollPane(
				textArea,
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		textArea.setEditable(false);
		getContentPane().add(scrollPane, BorderLayout.CENTER);

		JPanel bottomPanel = new JPanel();
		bottomPanel.setLayout(new BoxLayout(bottomPanel, BoxLayout.Y_AXIS));

		JPanel textPanel = new JPanel();
		textPanel.add(new JLabel("name"));
		textPanel.add(userName);
		textPanel.add(new JLabel("text"));
		textPanel.add(text);
		textPanel.add(bAppend);

		JPanel buttonPanel = new JPanel();
		buttonPanel.add(bClear);
		buttonPanel.add(bGet);

		bottomPanel.add(textPanel);
		bottomPanel.add(buttonPanel);

		getContentPane().add(bottomPanel, BorderLayout.SOUTH);

		initRemote();

		pack();
		setVisible(true);

	}
	class ActionHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == bClear)
				clean();
			if (e.getSource() == bAppend)
				appendText(userName.getText() + ": " + text.getText());
			if (e.getSource() == bGet)
				textArea.setText(getText());

		}
	}

	private void initRemote() {
		//to do - remote object connection
		//	- error handling
	}

	private void appendText(String text) {
		// to do
		//call the remote object clean method and handle exceptions with  displayError(String s)
	}


	private void clean() {
		// to do
		//call the remote object clean method and handle exceptions with  displayError(String s)

		textArea.setText("");
	}

	private String getText() {
		// to do
		//use displayError(String s)
		return "sorry";
	}


	private void displayError(String text) {
		JOptionPane.showInternalMessageDialog(
			this.getContentPane(),
			text,
			"error",
			JOptionPane.INFORMATION_MESSAGE);
	}

	private void log(String text) {
		textArea.append("local:" + text + "\n");
	}

	public static void main(String[] args) {
				new NoteBoardClient();
	}

}
